classdef MovementGenerator < handle
    properties
        dim; % dimensionality of the movement task (2D/3D)
        learnedModel; %
        curr_time = 0;
        curr_position; %will be define by the Benchmark toolbox
        curr_velocity; %will be define by the Benchmark toolbox
        target_position; %will be define by the Benchmark toolbox
        obstacle_b = 0; %will be define by the Benchmark toolbox
        obstacle; %will be define by the Benchmark toolbox
        stopSign = 0; %can be used for the model to signale the simulation it has stopped
        abortSign =0;
        bytes; %will be define by the Benchmark toolbox
        dt=0;
    end
    
    methods
        %% Constructor
        function p = MovementGenerator()
            
        end
        
        %% Functions which need to be implemented by user
        function init(p,dim)
            p.dim = dim;
        end
        
        function xd = step(p)
            % use your learner here
        end
        
        %% use this to signal the simulation that the movement trajectory is finished
        function doStop(p)
            p.stopSign = 1;
        end
        function undoStop(p)
            p.stopSign = 0;
        end
        function stop_b = checkStopped(p)
            stop_b = p.stopSign;
        end
        
        %% Default functions used in Benchmark framework DO NOT CHANGE
        function setCurrentTimeStep(p,t)
            p.curr_time = t;
        end       
        function setDt(p,dt)
            p.dt=dt;
        end
        function setCurrentPos(p,x)
            p.curr_position = x;
        end
        
        function setCurrentVel(p,v)
            p.curr_velocity = v;
        end
        
        function setCurrentTargetPos(p,x)
            p.target_position = x;
        end
        
        function setObstacleDetected(p,activ)
            p.obstacle_b = activ;
        end
        
        function setObstacle(p,x)
            p.obstacle = x;
        end
        
        function stop_b = checkAbourt(p)
            stop_b = p.abortSign;
        end
        
        function doAbourt(p)
            p.abortSign = 1;
        end
        function undoAbourt(p)
            p.abortSign = 0;
        end
        
        
        %% ------- copy ------------------------------
        function new = copy(this)
            
            new = feval(class(this));
            p = properties(this);
            for i = 1:length(p)
                if( isa(this.(p{i}), 'handle'))
                    new.(p{i}) = this.(p{i}).copy();
                elseif isa(this.(p{i}),'cell')
                    new.(p{i}) = deepCopyCellArray(numel(this.(p{i})));
                else
                    new.(p{i}) = this.(p{i});
                end
            end
        end
    end
end