%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%    Copyright (c) 2010 S. Mohammad Khansari-Zadeh, LASA Lab, EPFL,   %%%
%%%          CH-1015 Lausanne, Switzerland, http://lasa.epfl.ch         %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% The program is free for non-commercial academic use. Please contact the
% author if you are interested in using the software for commercial purposes.
% The software must not be modified or distributed without prior permission
% of the authors. Please acknowledge the authors in any academic publications
% that have made use of this code or part of it. Please use this BibTex for
% reference:
%
% S. M. Khansari-Zadeh and A. Billard, "Learning Stable Non-Linear Dynamical 
% Systems with Gaussian Mixture Models", IEEE Transaction on Robotics, 2011.
%
% To get latest upadate of the software please visit
%                          http://lasa.epfl.ch/khansari
%
% Please send your feedbacks or questions to:
%                           mohammad.khansari_at_epfl.ch
%
% converted to MovementGenerator Class by Andre Lemme 2013

classdef  SEDS_mg < MovementGenerator
    properties
        %properties in superclass
    end
    methods
        function p = SEDS_mg()
            p@MovementGenerator();
        end
        
        function init(p,model,dim)
            p.init@MovementGenerator(dim);
            p.learnedModel = model;
        end
        
        function xd = step(p)
            x_relative = p.curr_position-p.target_position;
            % use your learner here
            xd = SEDS(p.learnedModel, x_relative,1:p.dim,p.dim+1:2*p.dim);
            
            if norm(xd)<7.5 % a stopping tolerance
                p.doStop();
            end
        end
    end
end