classdef StateMachineUI < handle
    %GRASPASSISTANT Summary of this class goes here
    %   Detailed explanation goes here
    
    properties(SetObservable)
        app = [];
        parentup = [];
        uis = [];
        state = 0;
        ListenerObject=0;
        f=0;
        cid = 1;
        benchmarktype = {'generalization',...
            'discrete pushes',...
            'continuous pushes',...
            'changing target'};
        %'obstacle avoidance'...
    end
    events
        StateChange;
    end
    methods
        function ga = StateMachineUI(app, parentup)
            ga.app = app;
            
            if ~exist('parentup','var')
                ga.f = figure('Visible','off','Position',[400,300,500,50]);
                set(ga.f,'MenuBar','none');
                set(ga.f,'Units','normalized');
                set(ga.f,'Name','StateMachine');
                movegui(ga.f,'center');
                set(ga.f,'Visible','on');
                ga.parentup = ga.f;
            else
                ga.parentup = parentup;
            end
            
            ga.initUI();
        end
        % Positioning [left bottom width height]
        function initUI(ga)
            app = ga.app;
            ga.uis.label_selectMenu = uicontrol('Style', 'text','BackgroundColor','g',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.88 0.49 0.1],...
                'FontSize', 12,'String','Select Benchmark: ','TooltipString','Choose the benchmark to set its parameters.');
            ga.uis.selectMenu = uicontrol('Style', 'popupmenu',...
                'String',ga.benchmarktype,'Value',4,'Visible','on',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.89 0.49 0.1],...
                'FontSize', 12,'Callback',@ga.selectBenchmark);
            
            ga.uis.label_folder_models = uicontrol('Style', 'text',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.74 0.49 0.1],...
                'FontSize', 12,'String','Your model folder:','TooltipString','Please write the name of the folder that contains your models.');
            
            ga.uis.setfolder_models = uicontrol('Style', 'pushbutton',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.73 0.5 0.12],...
                'FontSize', 12,'String',app.parameterSet.folder_models,...
                'Callback',@ga.selectFolder);
            
            ga.uis.label_folder_library = uicontrol('Style', 'text',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.60 0.49 0.1],...
                'FontSize', 12,'String','Your library folder:','TooltipString','Please write the name of the folder that contains all the files for your algorithm.');
            
            ga.uis.setfolder_library = uicontrol('Style', 'pushbutton',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.59 0.5 0.12],...
                'FontSize', 12,'String',app.parameterSet.folder_library,...
                'Callback',@ga.selectFolder);
            
            ga.uis.label_folder_dataset = uicontrol('Style', 'text',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.46 0.49 0.1],...
                'FontSize', 12,'String','Dataset Folder:','TooltipString','Please write the name of the dataset folder.');
            
            ga.uis.setfolder_dataset = uicontrol('Style', 'pushbutton',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.45 0.5 0.12],...
                'FontSize', 12,'String',app.parameterSet.folder_dataset,...
                'Callback',@ga.selectFolder);
            
            
            ga.uis.label_model = uicontrol('Style', 'text',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.32 0.49 0.1],...
                'FontSize', 12,'String','Name of the demonstration');
            
            modelCell = getListofModels(ga.app);
            ga.uis.setmodel = uicontrol('Style', 'popupmenu',...
                'String',modelCell,'Value',1,'Visible','on',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.325 0.5 0.1],...
                'FontSize', 12);
            
             ga.uis.benchmarkControlPanel = uipanel('Title', 'Benchmark Control',...
                'Units','normalized',...
                'Parent',ga.parentup,'Position', [0.02 0.04 0.40 0.24],...
                'FontSize', 12, 'BackgroundColor', 'white');
            ga.uis.startstopPanel = uipanel('Title', 'Global Parameters',...
                'Units','normalized',...
                'Parent',ga.parentup,'Position', [0.44 0.04 0.40 0.24],...
                'FontSize', 12, 'BackgroundColor', 'white');
            % Positioning [left bottom width height]
            ga.uis.about_btn = uicontrol('Style', 'pushbutton',...
                'String','About','Min',0,'Max',1,...
                'Parent',ga.parentup,'Units','normalized','Position', [0.86 0.06 0.12 0.14],...
                'FontSize', 12,'Callback',@app.getAboutInformations,'TooltipString','Provides information about the developer of this framework.');
         
            
            ga.uis.saveParam_btn = uicontrol('Style', 'pushbutton',...
                'String','Save ','Min',0,'Max',1,...
                'Parent',ga.uis.startstopPanel,'Units','normalized','Position', [0.025 0.05 0.45 0.9],...
                'FontSize', 12,'Callback',@app.saveParam);
            ga.uis.loadParam_btn = uicontrol('Style', 'pushbutton',...
                'String','Load ','Min',0,'Max',1,...
                'Parent',ga.uis.startstopPanel,'Units','normalized','Position', [0.525 0.05 0.45 0.9],...
                'FontSize', 12,'Callback',@app.loadParam);

            
            
            
            ga.uis.start_btn = uicontrol('Style', 'pushbutton',...
                'String','START','Min',0,'Max',1,...
                'Parent',ga.uis.benchmarkControlPanel,'Units','normalized','Position', [0.025 0.05 0.45 0.9],...
                'FontSize', 12,'Callback',@app.startBenchmark);
            ga.uis.stop_btn = uicontrol('Style', 'pushbutton',...
                'String','STOP','Min',0,'Max',1,...
                'Parent',ga.uis.benchmarkControlPanel,'Units','normalized','Position', [0.525 0.05 0.45 0.9],...
                'FontSize', 12,'Callback',@app.stopBenchmak);
            
           
        end
        
        function selectBenchmark(ga,src,evn)
            cstr = get(ga.uis.selectMenu, 'Value');
            ga.cid = cstr;
            ga.setState(cstr);
        end
        
        function setState(ga, state)
            ga.app.PushesParam.hideUI();
            ga.app.ContPushesParam.hideUI();
            ga.app.TargetChangeParam.hideUI();
            ga.app.GeneralizationParam.hideUI();
            switch state
                case 1;
                    ga.app.GeneralizationParam.showUI();
                case 2;
                    ga.app.PushesParam.showUI();
                case 3;
                    ga.app.ContPushesParam.showUI();
                case 4;
                    ga.app.TargetChangeParam.showUI();
                otherwise
                    waring('state does not exist')
            end
            ga.app.currState = state;
        end
        
        function [state, numSt] = getState(ga)
            
            switch ga.app.currState
                case 1;
                    state = 'generalization';
                case 2;
                    state = 'discretePush';
                case 3;
                    state = 'continuousPush';
                case 4;
                    state = 'targetChange';
                otherwise
                    waring('state does not exist')
            end
            numSt =ga.app.currState;
        end
        
        function getParameters(ga)
            
            ga.app.parameterSet.folder_models = (get(ga.uis.setfolder_models,'String'));
            ga.app.parameterSet.folder_library= (get(ga.uis.setfolder_library,'String'));
            ga.app.parameterSet.folder_dataset= (get(ga.uis.setfolder_dataset,'String'));
            list=get(ga.uis.setmodel,'String');
            val=get(ga.uis.setmodel,'Value');
            
            
            if strcmp(list{val},'all')
                ga.app.parameterSet.model = list(1:length(list)-1);
            else
                ga.app.parameterSet.model = list(val);
            end
        end
        
        function setParameters(ga, param)
            
            set(ga.uis.setfolder_models,'String',param.folder_models);
            set(ga.uis.setfolder_library,'String',param.folder_library);
            set(ga.uis.setfolder_dataset,'String',param.folder_dataset);
            
            modelCell = getListofModels(ga.app);
            set(ga.uis.setmodel,'String',modelCell);
        end
        
        function selectFolder(ga,src,evn)
            path = pwd;
            folder_name = uigetdir(path);
            
            if folder_name ~= 0
                ind = strfind(folder_name,filesep);
                set(src,'String',folder_name(ind(end)+1:end));
                
                %% updating the list of files in this folder
                switch  src
                    case ga.uis.setfolder_dataset
                        ga.app.parameterSet.folder_dataset = folder_name(ind(end)+1:end);
                    case ga.uis.setfolder_models
                        ga.app.parameterSet.folder_models = folder_name(ind(end)+1:end);
                end
                modelCell = getListofModels(ga.app);
                set(ga.uis.setmodel,'String',modelCell);
            end
        end
    end
end


function modelCell = getListofModels(app)
if exist([app.parameterSet.folder_dataset filesep app.parameterSet.folder_models],'dir')
    tmpModels = dir([app.parameterSet.folder_dataset filesep app.parameterSet.folder_models filesep '*.mat']);
    modelCell = cell(length(tmpModels),1);
    for i = 1:length(tmpModels)
        modelCell{i} =tmpModels(i).name;
    end
    modelCell{i+1} ='all';
else
    tmpModels = [];
    modelCell = [];
end
end