classdef  TargetChangeParam < PushesParam
    %TargetChangeParam Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        
        
    end
    
    methods
        function ga = TargetChangeParam(app, parentup)
            if nargin < 2
                f = figure('Visible','off','Position',[400,300,500,50]);
                set(f,'MenuBar','none');
                set(f,'Units','normalized');
                set(f,'Name','Parameter Assistant');
                movegui(f,'center');
                set(f,'Visible','on');
                parentup = f;
            end
            ga@PushesParam(app,parentup);
            
            
        end
        
        function updateUI(ga)
            set(ga.app.gui.statePanel,'Title', 'Parameters for moving target benchmark')
            set(ga.uis.setStart_time,'String',num2str(ga.app.parameterSet.target.start_time));
            set(ga.uis.setDuration,'String',num2str(ga.app.parameterSet.target.duration));
            set(ga.uis.setAmplitude,'String',num2str(ga.app.parameterSet.target.amplitude));
            set(ga.uis.setVector,'String',matrix2str(ga.app.parameterSet.target.vector));
            set(ga.uis.setresultFile,'String', ga.app.parameterSet.target.resultFile);
            set(ga.uis.setPlottingWaitTime,'String',num2str(ga.app.parameterSet.target.plot_wait_time));
            set(ga.uis.checkPlot,'Value', ga.app.parameterSet.target.plot)
            set(ga.uis.checkRun,'Value', ga.app.parameterSet.target.run)
            
        end
        function getParameters(ga)
            ga.app.parameterSet.target.duration = str2num(get(ga.uis.setDuration,'String'));
            ga.app.parameterSet.target.duration(ga.app.parameterSet.target.duration<0) = 0;
            ga.app.parameterSet.target.duration(ga.app.parameterSet.target.duration>1) = 1;
            
            ga.app.parameterSet.target.start_time= str2num(get(ga.uis.setStart_time,'String'));
            ga.app.parameterSet.target.start_time(ga.app.parameterSet.target.start_time<0) = 0;
            ga.app.parameterSet.target.start_time(ga.app.parameterSet.target.start_time>1) = 1;
            
            ga.app.parameterSet.target.amplitude= str2num(get(ga.uis.setAmplitude,'String'));
            
            ga.app.parameterSet.target.vector = str2num(get(ga.uis.setVector,'String'));
            
            ga.app.parameterSet.target.resultFile = get(ga.uis.setresultFile,'String');
            ga.app.parameterSet.target.plot_wait_time = str2num(get(ga.uis.setPlottingWaitTime,'String'));
            
            ga.app.parameterSet.target.plot = get(ga.uis.checkPlot,'Value');
            ga.app.parameterSet.target.run = get(ga.uis.checkRun,'Value');
            ga.app.parameterSet.target.animation =get(ga.uis.checkAnimation,'Value');
        end
        
        function initUI(ga)
            
            
            param = ga.app.parameterSet.target;
            app =ga.app;
            ga.uis.randParam_btn = uicontrol('Style', 'pushbutton',...
                'String','Shuffel Param.','Min',0,'Max',1,...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.025 0.3 0.1],...
                'FontSize', 12,'Callback',@app.getRandParameters,'TooltipString','Generate random Sample for the selected Benchmarktype');
            
            ga.uis.setNumSample = uicontrol('Style', 'edit',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.82 0.025 0.15 0.1],...
                'FontSize', 12,'String','1','TooltipString','Number of samples to generate randomly');
            
            ga.uis.checkRun = uicontrol('Style', 'checkbox',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.025 0.49 0.1],...
                'FontSize', 12,'String','Run Benchmark','value',param.run,...
                'TooltipString','When checked the benchmark is added to the list of benchmark typs that will be processed after pressing START');
            
            ga.uis.checkPlot = uicontrol('Style', 'checkbox',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.14 0.49 0.1],...
                'FontSize', 12,'String','Mark Benchmark for Plotting','value',param.plot);
            
            ga.uis.checkAnimation = uicontrol('Style', 'checkbox',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.14 0.5 0.1],...
                'FontSize', 12,'String','Activate Animation','value',param.animation);
            
            ga.uis.label_setPlottingWaitTime = uicontrol('Style', 'text',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.255 0.49 0.1],...
                'FontSize', 12,'String','Waiting time:',...
                'TooltipString','Waiting time in sec between plots. -1 = wait that you press ENTER.');
            
            ga.uis.setPlottingWaitTime = uicontrol('Style', 'edit',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.255 0.1 0.1],...
                'FontSize', 12,'String',num2str(param.plot_wait_time));
            
            ga.uis.label_setresultFile = uicontrol('Style', 'text',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.38 0.49 0.1],...
                'FontSize', 12,'String','Filename to save the results:',...
                'TooltipString','File to save the results of this benchmark.');
            
            ga.uis.setresultFile = uicontrol('Style', 'edit',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.38 0.5 0.1],...
                'FontSize', 12,'String',param.resultFile);
            
            ga.uis.label_start_time = uicontrol('Style', 'text',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.505 0.49 0.1],...
                'FontSize', 12,'String','Perturbation time:',...
                'TooltipString','Defining the moment as a factor of the total duration of the motion (value between 0 and 1) at which perturbation should be applied.');
            
            ga.uis.setStart_time = uicontrol('Style', 'edit',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.505 0.5 0.1],...
                'FontSize', 12,'String',num2str(param.start_time));
            
            ga.uis.label_duration = uicontrol('Style', 'text',...
               'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.63 0.49 0.1],...
               'FontSize', 12,'String','Duration of the perturbation',...
               'TooltipString','This value is normalized by the total duration of the motion (i.e. value between 0 and 1)');
           
            ga.uis.setDuration = uicontrol('Style', 'edit',...
               'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.63 0.5 0.1],...
               'FontSize', 12,'String',num2str(param.duration));
            
            ga.uis.label_amplitude = uicontrol('Style', 'text',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.755 0.49 0.1],...
                'FontSize', 12,'String','Perturbation Amplitude:',...
                'TooltipString','The amplitude of the perturbation (multiplier of a normalized vector).');
            
            ga.uis.setAmplitude = uicontrol('Style', 'edit',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.755 0.5 0.1],...
                'FontSize', 12,'String',num2str(param.amplitude));
            
            ga.uis.label_vector = uicontrol('Style', 'text',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.0 0.88 0.49 0.1],...
                'FontSize', 12,'String','Perturbation Direction:',...
                'TooltipString','These vectors define the direction and will be normalized.');
            
            ga.uis.setVector = uicontrol('Style', 'edit',...
                'Parent',ga.parentup,'Units','normalized','Position', [0.5 0.88 0.5 0.1],...
                'FontSize', 12,'String',matrix2str(param.vector));
        end
        
       
    end
    
end

