function dT = EvalDHDerivMatrix( angle, DH )
% computes the derivative of the roto-translation matrix with respect to
% the theta variable of link n using the DH of the current link
theta = angle + DH.offset;
alpha = DH.alpha;

c_theta = cos(theta);
s_theta = sin(theta);
c_alpha = cos(alpha);
s_alpha = sin(alpha);

dT=[[-s_theta   -c_theta * c_alpha    c_theta * s_alpha     -DH.A * s_theta];...
    [ c_theta   -s_theta * c_alpha    s_theta * s_alpha      DH.A * c_theta];...
    [ 0          0                    0                      0             ];...
    [ 0          0                    0                      0             ]];


end

