function T = EvalDHMatrix(angle, DH)
%Evaluates the roto-translation matrix using the DH of the current link

theta = angle + DH.offset;
alpha = DH.alpha;

c_theta = cos(theta);
s_theta = sin(theta);
c_alpha = cos(alpha);
s_alpha = sin(alpha);

                
T=[[c_theta     -s_theta * c_alpha     s_theta * s_alpha     DH.A * c_theta  ];...
   [s_theta      c_theta * c_alpha    -c_theta * s_alpha     DH.A * s_theta  ];...
   [0            s_alpha               c_alpha               DH.D            ];...
   [0            0                     0                     1               ]];

end