function [totalR2, R2iw, R2iw_repro ]=AnalyzeDemosPowerLaw(positions,pos_reproduced,dts,RsqrThreshold,TimeWindows,draw)
%meanposition=nanmean(positions,3);
if ~iscell(positions)
    positions=squeeze(mat2cell(positions,2,1000,ones(1,7)))';
end
if ~exist('draw','var')
    draw=1;
end

if draw
    figure;
    subplotD=ceil(sqrt(size(positions,2)+2));
end

for idemo=1:size(positions,2)
    
    [R2iw(idemo,:,:)]=PowerLawCompliance(positions{idemo}',dts(idemo),TimeWindows);
    highR2=(R2iw(idemo,:,1)>RsqrThreshold);
    
    if draw
        subplot(subplotD,subplotD,idemo+1);
        errorbar(TimeWindows(highR2),R2iw(idemo,highR2,1),-R2iw(idemo,highR2,2),R2iw(idemo,highR2,2),'.','color',[72 72 72]/255);
        line([0 max(TimeWindows)],[RsqrThreshold RsqrThreshold]);
        hold on; errorbar(TimeWindows(~highR2),R2iw(idemo,~highR2,1),-R2iw(idemo,~highR2,2),R2iw(idemo,~highR2,2),'.','color',[172 172 172]/255);
        title(['d.' num2str(idemo) '   ' num2str(1000*dts(idemo),2) ' [sec]']);
    end
    
end

totalR2=squeeze(nanmean(R2iw,1));
highR2tot=all(R2iw(:,:,1)>RsqrThreshold);

if draw
    set(get(gcf,'children'),'xlim',[0 max(TimeWindows)],'ylim',[0 1] )
    if ~isempty(totalR2(highR2tot,1))
        subplot(subplotD,subplotD,idemo+2);
        errorbar(TimeWindows(highR2tot),totalR2(highR2tot,1),-totalR2(highR2tot,2),totalR2(highR2tot,2),'.','color',[172 72 72]/255,'linewidth',2);
        axis([0 max(TimeWindows) 0 1]);
    end
    line([0 max(TimeWindows)],[RsqrThreshold RsqrThreshold]);
    ylabel('R^2');
    xlabel('segment duration [sec]');

    subplot(subplotD,subplotD,1);
    %plot(meanposition(1,:),meanposition(2,:),'linewidth',2,'color',[0 0 0]/255); hold on;
    for idemo=1:size(positions,2)
        plot(positions{idemo}(1,:),positions{idemo}(2,:),'color',[192 192 192]/255);
    end
    hold off
    axis equal
    title('shape');
    %xlabel('[cm]'); ylabel('[cm]');
end

if exist('pos_reproduced','var') && ~isempty(pos_reproduced)
    dt=0.0021;
    [R2iw_repro]=PowerLawCompliance(pos_reproduced,dt,TimeWindows);
    highR2=(R2iw_repro(:,1)>RsqrThreshold);
    if draw
        figure;
        errorbar(TimeWindows(highR2),R2iw_repro(highR2,1),-R2iw_repro(highR2,2),R2iw_repro(highR2,2),'.','color',[72 72 72]/255);
        axis([0 max(TimeWindows) 0 1]);
    end
end
