function [ outputDemo, outputRepro ] = ResampleData( demoTraj, reproTraj )
%RESAMPLEDATA Resamples the reproTraj to with the same amount of Samples
%which are in demoTraj without changing the velocity profile
%  INPUT 
%       demoTraj  = MxN trajectory 
%       reproTraj = OxN trajectory 
%      
%  OUTPUT 
%       outputDemo  = MxN trajectory 
%       outputRepro = MxN trajectory 
%
nDataDemo = size(demoTraj, 1);
nDataRepro = size(reproTraj, 1);
nData = max(nDataDemo, nDataDemo);


outputDemo = [];
outputRepro = [];
if nDataRepro > 1
    reproTraj=interp1(1:size(reproTraj,1),reproTraj ,(1:size(demoTraj,1))/size(demoTraj,1)*size(reproTraj,1),'spline');  
else
    reproTraj = repmat(reproTraj,nDataDemo,1);
end


outputDemo=demoTraj;
outputRepro=reproTraj;
end

