function parameters=evaluateDemos(demos,draw)
% parameters=evaluateDemos(demos) runs the R2 evaluation of the
% demonstration to be used as ground truth in the evaluation of the
% reproductions
% demos, the demonstration as a cell os structures 
% parameters, container of the evaluation

% constants
R2threshold=0.35;
TimeWindows=[0.2:0.1:2];

% initial analysis of demos
demoarray=cell2mat(demos);
positions=cat(3,demoarray.pos);
dts=cat(1,demoarray.dt);
[totalR2_demo,R2iw_dem]=AnalyzeDemosPowerLaw(positions,[],dts,R2threshold,TimeWindows,draw);

parameters.R2threshold=R2threshold;
parameters.TimeWindows=TimeWindows;
parameters.alldemos_high=find(all(R2iw_dem(:,:,1)>R2threshold));
parameters.totalR2_demo=totalR2_demo;
parameters.R2iw_dem=R2iw_dem;

