function samples = generateRandomBaselineParameters(nbSamples, benchmarkType)

%computing random values for the vector of perturbations
samples.vector = rand(2,nbSamples) - 0.5;
samples.vector = samples.vector./repmat(sqrt(sum(samples.vector.^2,1)),2,1);

if strcmpi(benchmarkType,'generalization')
    %computing random values for the amplitude of perturbations
    meanAmplitude = 0.2*50; %50 span of the motion
    standardDeviation = 0.1*50; 
    samples.amplitude = standardDeviation*randn(1,nbSamples) + meanAmplitude;
    
elseif strcmpi(benchmarkType,'discretePush')
    %computing random values for the amplitude of perturbations
    meanAmplitude = 0.1*50; %50 span of the motion
    standardDeviation = 0.05*50; 
    samples.amplitude = standardDeviation*randn(1,nbSamples) + meanAmplitude;
    
    %computing random values for time
    samples.time = rand(1,nbSamples);
   
elseif strcmpi(benchmarkType,'continuousPush') || strcmpi(benchmarkType,'targetChange')
    
    %computing random values for the amplitude of perturbations
    meanAmplitude = 0.5*20.7315; %mean of all speeds is 20.7315
    standardDeviation = 0.25*20.7315; 
    samples.amplitude = standardDeviation*randn(1,nbSamples) + meanAmplitude;
    
    %computing random values for time
    samples.time = rand(1,nbSamples);
    samples.duration = 0.2*rand(1,nbSamples) + 0.1;
end
        
