function fit = goodnessOfFitStatisticR2(demo,repro)
%goodnessOfFitStatisticR2   scores fittness of reproduction
%   for more details see:
%   Uri Maoz, Alain Berthoz, and Tamar Flash, "Complex Unconstrained Three-
%   Dimensional Hand Movement and Constant Equi-Affine Speed", 
%   submitted to J Neurophysiol, 2009 
%
%   OUTPUT:
%       - fit scalar value usually positive
%       
%   INPUT:
%       - demo array of N-D trajectories (NxM)
%       - repro array of N-D trajectories (NxM)
%
% author: alemme

[N M]= size(demo);
% compute Error

A = (sum((demo-repro).^2,2)); 

% Mean value
meanDemo= mean(demo,2); 
% error to mean Value
B = (sum((demo-repmat(meanDemo,1,size(demo,2))).^2,2)); 
B(B==0)= 1e-16; %
% Fittness
fit=mean( 1-(A./B)); 
end

