function [fit]= vssqVelocityMeasure(demo,repro)
%VSSQVELOCITYMEASURE   numerical estimates the degree of fit between the
%   simulated and the measured velocity profiles
%
%   VSSQVELOCITYMEASURE(demos, repro) returns fit == 0
%   if the trajcetory profiles are the same.
%
%   INPUT:
%       - NAME string used in the title of the plot
%       - DEMOS array of set s of ND trajectories (demos{i}(1:d,:)) and
%       velocity in (demos{i}(d+1:2*d,:))
%
%   Henis Ealan and T.Flash, "Mechanisms underlying the generation of
%   averaged modified trajectories", Biological Cybernetics 1995, V. 72,
%   pp. 407-419
%
%


d=size(demo,1)/2;
if d <2 
    warning('one dim task?')
end
X=zeros(d,1);
for i=1:d
    X(i)=0.5*sum((demo(d+i,:)-repro(d+i,:)).^2)/(sum(demo(d+i,:).^2));
end
fit=sum(X);

end

