function AnimateiCub( q , target, obstacle)

    jointAngles = [ 0 0 0 q(1) q(2) q(3) q(4) 0 0 0];
 
%    cd ../fwd-inv-kinematics;
    DH = DHParams();
    
    
    DHMat4 = EvalDHMatrix(jointAngles(4), DH{4});
    DHMat5 = EvalDHMatrix(jointAngles(5), DH{5});
    DHMat6 = EvalDHMatrix(jointAngles(6), DH{6});
    DHMat7 = EvalDHMatrix(jointAngles(7), DH{7});
    DHMat8 = EvalDHMatrix(jointAngles(8), DH{8});
    DHMat9 = EvalDHMatrix(jointAngles(9), DH{9});
    DHMat10 = EvalDHMatrix(jointAngles(10), DH{10});
    
    G_sL3 = ArmTRo0();
    G_sL4 = G_sL3 * DHMat4;
    G_sL5 = G_sL4 * DHMat5;
    G_sL6 = G_sL5 * DHMat6;
    G_sL7 = G_sL6 * DHMat7;
    G_sL8 = G_sL7 * DHMat8;
    G_sL9 = G_sL8 * DHMat9;
    G_sL10 = G_sL9 * DHMat10;
 %   cd ../visualization


    ljnt = 20;  %joint pic length
    rjnt = 5; %joint pic radius
    LinkColor1 = [1 0 0];   %RGB color of the first link
    LinkColor2 = [1 0 0];   %RGB color of the second link
    LinkColor3 = [1 0 0];   %RGB color of the third link
    JntColor   = [.7 .7 .7];%RGB color of the joints

%     jnt2 = DrawCylinder(ljnt, rjnt, G_sL0*[1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.5);
%     
%     jnt3 = DrawCylinder(ljnt, rjnt, G_sL1*[1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.5);
%     jnt4 = DrawCylinder(ljnt, rjnt, G_sL2*[1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.5);
% 
%     DrawRefFrame(G_sL0,0)
%     DrawRefFrame(G_sL1,1)
%     DrawRefFrame(G_sL2,2)

    % jnt1 = DrawCylinder(ljnt, rjnt, G_sL0 * [1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.8);
    clf;
    jnt2 = DrawCylinder(ljnt, rjnt, G_sL3*[1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.5);
    hold on
    jnt3 = DrawCylinder(ljnt, rjnt, G_sL4*[1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.5);
    jnt4 = DrawCylinder(ljnt, rjnt, G_sL5*[1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.5);
    jnt5 = DrawCylinder(ljnt, rjnt, G_sL6*[1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.5);
    jnt6 = DrawCylinder(ljnt, rjnt, G_sL7*[1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.5);
    jnt7 = DrawCylinder(ljnt, rjnt, G_sL8*[1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.5);
    jnt8 = DrawCylinder(ljnt, rjnt, G_sL9*[1 0 0 0; 0 1 0 0; 0 0 1 -ljnt/2; 0 0 0 1], JntColor, 100, 0.5);
    % %
    cy0 = DrawCylinder(-107.74, 20, G_sL3, LinkColor1, 100, 0.1);
    cy0 = DrawCylinder(-152.28, 10, G_sL5, LinkColor1, 100, 0.1);
    cy1 = DrawCylinder(-137.3, 5, G_sL7, LinkColor1, 100, 0.1);
    % Palm
    cy2 = DrawRectangle(G_sL10*[eye(3), [-42.5/2 0 0]'; 0 0 0 1],  42.5, 30, 10);

%     DrawRefFrame(G_sL3,3)
%     DrawRefFrame(G_sL4,4)
%     DrawRefFrame(G_sL5,5)
%     DrawRefFrame(G_sL6,6)
%     DrawRefFrame(G_sL7,7)
%     DrawRefFrame(G_sL8,8)
%     DrawRefFrame(G_sL9,9)
%     DrawRefFrame(G_sL10,10)
    
    %DrawRightHand(G_sL10)
    
    %Drawing target
    DrawSphere(target.position, target.radius, [0 1 0]);
    
    %Drawing obstacle
    if(obstacle.exists)
        DrawSphere(obstacle.position, obstacle.radius, [1 0 0]);
    end
    
    axis('equal')
    xlabel('x')
    ylabel('y')
    zlabel('z')
    
    xlim([-400 50]);
    ylim([0 400]);
    zlim([-250 200]);

    L1 = light;
    set(L1, 'Position', [-20 -20 -2]);
    L2 = light;
    set(L2, 'Position', [20 20 2]);
    
    campos([-2600 -1500 2300]); %frontal side view (standard)
    %campos([-175 200 3733]); %upper view
    %drawnow expose
    
end

